diff --git a/src/backend/commands/analyze.c b/src/backend/commands/analyze.c
index 2da6b75a15..fe0b81d99e 100644
--- a/src/backend/commands/analyze.c
+++ b/src/backend/commands/analyze.c
@@ -95,7 +95,7 @@ static void compute_index_stats(Relation onerel, double totalrows,
 								AnlIndexData *indexdata, int nindexes,
 								HeapTuple *rows, int numrows,
 								MemoryContext col_context);
-static VacAttrStats *examine_attribute(Relation onerel, int attnum,
+static VacAttrStats *examine_attribute(Relation onerel, int attphysnum,
 									   Node *index_expr);
 static int	acquire_sample_rows(Relation onerel, int elevel,
 								HeapTuple *rows, int targrows,
@@ -574,7 +574,7 @@ do_analyze_rel(Relation onerel, VacuumParams *params,
 			 * If the appropriate flavor of the n_distinct option is
 			 * specified, override with the corresponding value.
 			 */
-			aopt = get_attribute_options(onerel->rd_id, stats->attr->attnum);
+			aopt = get_attribute_options(onerel->rd_id, stats->attr->attphysnum);
 			if (aopt != NULL)
 			{
 				float8		n_distinct;
@@ -928,16 +928,16 @@ compute_index_stats(Relation onerel, double totalrows,
 				for (i = 0; i < attr_cnt; i++)
 				{
 					VacAttrStats *stats = thisdata->vacattrstats[i];
-					int			attnum = stats->attr->attnum;
+					int			attphysnum = stats->attr->attphysnum;
 
-					if (isnull[attnum - 1])
+					if (isnull[attphysnum - 1])
 					{
 						exprvals[tcnt] = (Datum) 0;
 						exprnulls[tcnt] = true;
 					}
 					else
 					{
-						exprvals[tcnt] = datumCopy(values[attnum - 1],
+						exprvals[tcnt] = datumCopy(values[attphysnum - 1],
 												   stats->attrtype->typbyval,
 												   stats->attrtype->typlen);
 						exprnulls[tcnt] = false;
@@ -998,9 +998,9 @@ compute_index_stats(Relation onerel, double totalrows,
  * and index_expr is the expression tree representing the column's data.
  */
 static VacAttrStats *
-examine_attribute(Relation onerel, int attnum, Node *index_expr)
+examine_attribute(Relation onerel, int attphysnum, Node *index_expr)
 {
-	Form_pg_attribute attr = TupleDescAttr(onerel->rd_att, attnum - 1);
+	Form_pg_attribute attr = TupleDescAttr(onerel->rd_att, attphysnum - 1);
 	HeapTuple	typtuple;
 	VacAttrStats *stats;
 	int			i;
@@ -1041,8 +1041,8 @@ examine_attribute(Relation onerel, int attnum, Node *index_expr)
 		 * preference to anything else; but if not, fall back to whatever we
 		 * can get from the expression.
 		 */
-		if (OidIsValid(onerel->rd_indcollation[attnum - 1]))
-			stats->attrcollid = onerel->rd_indcollation[attnum - 1];
+		if (OidIsValid(onerel->rd_indcollation[attphysnum - 1]))
+			stats->attrcollid = onerel->rd_indcollation[attphysnum - 1];
 		else
 			stats->attrcollid = exprCollation(index_expr);
 	}
@@ -1059,7 +1059,7 @@ examine_attribute(Relation onerel, int attnum, Node *index_expr)
 		elog(ERROR, "cache lookup failed for type %u", stats->attrtypid);
 	stats->attrtype = (Form_pg_type) GETSTRUCT(typtuple);
 	stats->anl_context = anl_context;
-	stats->tupattnum = attnum;
+	stats->tupattnum = attphysnum;
 
 	/*
 	 * The fields describing the stats->stavalues[n] element types default to
@@ -1656,7 +1656,7 @@ update_attstats(Oid relid, bool inh, int natts, VacAttrStats **vacattrstats)
 		}
 
 		values[Anum_pg_statistic_starelid - 1] = ObjectIdGetDatum(relid);
-		values[Anum_pg_statistic_staattnum - 1] = Int16GetDatum(stats->attr->attnum);
+		values[Anum_pg_statistic_staattnum - 1] = Int16GetDatum(stats->attr->attphysnum);
 		values[Anum_pg_statistic_stainherit - 1] = BoolGetDatum(inh);
 		values[Anum_pg_statistic_stanullfrac - 1] = Float4GetDatum(stats->stanullfrac);
 		values[Anum_pg_statistic_stawidth - 1] = Int32GetDatum(stats->stawidth);
@@ -1725,7 +1725,7 @@ update_attstats(Oid relid, bool inh, int natts, VacAttrStats **vacattrstats)
 		/* Is there already a pg_statistic tuple for this attribute? */
 		oldtup = SearchSysCache3(STATRELATTINH,
 								 ObjectIdGetDatum(relid),
-								 Int16GetDatum(stats->attr->attnum),
+								 Int16GetDatum(stats->attr->attphysnum),
 								 BoolGetDatum(inh));
 
 		if (HeapTupleIsValid(oldtup))
@@ -1761,11 +1761,11 @@ update_attstats(Oid relid, bool inh, int natts, VacAttrStats **vacattrstats)
 static Datum
 std_fetch_func(VacAttrStatsP stats, int rownum, bool *isNull)
 {
-	int			attnum = stats->tupattnum;
+	int			attphysnum = stats->tupattnum;
 	HeapTuple	tuple = stats->rows[rownum];
 	TupleDesc	tupDesc = stats->tupDesc;
 
-	return heap_getattr(tuple, attnum, tupDesc, isNull);
+	return heap_getattr(tuple, attphysnum, tupDesc, isNull);
 }
 
 /*
diff --git a/src/backend/commands/copy.c b/src/backend/commands/copy.c
index e2870e3c11..6b15837dba 100644
--- a/src/backend/commands/copy.c
+++ b/src/backend/commands/copy.c
@@ -739,11 +739,11 @@ CopyGetAttnums(TupleDesc tupDesc, Relation rel, List *attnamelist)
 		foreach(l, attnamelist)
 		{
 			char	   *name = strVal(lfirst(l));
-			int			attnum;
+			int			attphysnum;
 			int			i;
 
 			/* Lookup column name */
-			attnum = InvalidAttrNumber;
+			attphysnum = InvalidAttrNumber;
 			for (i = 0; i < tupDesc->natts; i++)
 			{
 				Form_pg_attribute att = TupleDescAttr(tupDesc, i);
@@ -758,11 +758,11 @@ CopyGetAttnums(TupleDesc tupDesc, Relation rel, List *attnamelist)
 								 errmsg("column \"%s\" is a generated column",
 										name),
 								 errdetail("Generated columns cannot be used in COPY.")));
-					attnum = att->attnum;
+					attphysnum = att->attphysnum;
 					break;
 				}
 			}
-			if (attnum == InvalidAttrNumber)
+			if (attphysnum == InvalidAttrNumber)
 			{
 				if (rel != NULL)
 					ereport(ERROR,
@@ -776,12 +776,12 @@ CopyGetAttnums(TupleDesc tupDesc, Relation rel, List *attnamelist)
 									name)));
 			}
 			/* Check for duplicates */
-			if (list_member_int(attnums, attnum))
+			if (list_member_int(attnums, attphysnum))
 				ereport(ERROR,
 						(errcode(ERRCODE_DUPLICATE_COLUMN),
 						 errmsg("column \"%s\" specified more than once",
 								name)));
-			attnums = lappend_int(attnums, attnum);
+			attnums = lappend_int(attnums, attphysnum);
 		}
 	}
 
diff --git a/src/backend/commands/copyfrom.c b/src/backend/commands/copyfrom.c
index 35a1d3a774..ca44d12b11 100644
--- a/src/backend/commands/copyfrom.c
+++ b/src/backend/commands/copyfrom.c
@@ -1202,7 +1202,7 @@ BeginCopyFrom(ParseState *pstate,
 				num_defaults;
 	FmgrInfo   *in_functions;
 	Oid		   *typioparams;
-	int			attnum;
+	int			attphysnum;
 	Oid			in_func_oid;
 	int		   *defmap;
 	ExprState **defexprs;
@@ -1258,15 +1258,15 @@ BeginCopyFrom(ParseState *pstate,
 
 		foreach(cur, attnums)
 		{
-			int			attnum = lfirst_int(cur);
-			Form_pg_attribute attr = TupleDescAttr(tupDesc, attnum - 1);
+			int			attphysnum = lfirst_int(cur);
+			Form_pg_attribute attr = TupleDescAttr(tupDesc, attphysnum - 1);
 
-			if (!list_member_int(cstate->attnumlist, attnum))
+			if (!list_member_int(cstate->attnumlist, attphysnum))
 				ereport(ERROR,
 						(errcode(ERRCODE_INVALID_COLUMN_REFERENCE),
 						 errmsg("FORCE_NOT_NULL column \"%s\" not referenced by COPY",
 								NameStr(attr->attname))));
-			cstate->opts.force_notnull_flags[attnum - 1] = true;
+			cstate->opts.force_notnull_flags[attphysnum - 1] = true;
 		}
 	}
 
@@ -1281,15 +1281,15 @@ BeginCopyFrom(ParseState *pstate,
 
 		foreach(cur, attnums)
 		{
-			int			attnum = lfirst_int(cur);
-			Form_pg_attribute attr = TupleDescAttr(tupDesc, attnum - 1);
+			int			attphysnum = lfirst_int(cur);
+			Form_pg_attribute attr = TupleDescAttr(tupDesc, attphysnum - 1);
 
-			if (!list_member_int(cstate->attnumlist, attnum))
+			if (!list_member_int(cstate->attnumlist, attphysnum))
 				ereport(ERROR,
 						(errcode(ERRCODE_INVALID_COLUMN_REFERENCE),
 						 errmsg("FORCE_NULL column \"%s\" not referenced by COPY",
 								NameStr(attr->attname))));
-			cstate->opts.force_null_flags[attnum - 1] = true;
+			cstate->opts.force_null_flags[attphysnum - 1] = true;
 		}
 	}
 
@@ -1305,15 +1305,15 @@ BeginCopyFrom(ParseState *pstate,
 
 		foreach(cur, attnums)
 		{
-			int			attnum = lfirst_int(cur);
-			Form_pg_attribute attr = TupleDescAttr(tupDesc, attnum - 1);
+			int			attphysnum = lfirst_int(cur);
+			Form_pg_attribute attr = TupleDescAttr(tupDesc, attphysnum - 1);
 
-			if (!list_member_int(cstate->attnumlist, attnum))
+			if (!list_member_int(cstate->attnumlist, attphysnum))
 				ereport(ERROR,
 						(errcode(ERRCODE_INVALID_COLUMN_REFERENCE),
 						 errmsg_internal("selected column \"%s\" not referenced by COPY",
 										 NameStr(attr->attname))));
-			cstate->convert_select_flags[attnum - 1] = true;
+			cstate->convert_select_flags[attphysnum - 1] = true;
 		}
 	}
 
@@ -1401,9 +1401,9 @@ BeginCopyFrom(ParseState *pstate,
 	defmap = (int *) palloc(num_phys_attrs * sizeof(int));
 	defexprs = (ExprState **) palloc(num_phys_attrs * sizeof(ExprState *));
 
-	for (attnum = 1; attnum <= num_phys_attrs; attnum++)
+	for (attphysnum = 1; attphysnum <= num_phys_attrs; attphysnum++)
 	{
-		Form_pg_attribute att = TupleDescAttr(tupDesc, attnum - 1);
+		Form_pg_attribute att = TupleDescAttr(tupDesc, attphysnum - 1);
 
 		/* We don't need info for dropped attributes */
 		if (att->attisdropped)
@@ -1412,19 +1412,19 @@ BeginCopyFrom(ParseState *pstate,
 		/* Fetch the input function and typioparam info */
 		if (cstate->opts.binary)
 			getTypeBinaryInputInfo(att->atttypid,
-								   &in_func_oid, &typioparams[attnum - 1]);
+								   &in_func_oid, &typioparams[attphysnum - 1]);
 		else
 			getTypeInputInfo(att->atttypid,
-							 &in_func_oid, &typioparams[attnum - 1]);
-		fmgr_info(in_func_oid, &in_functions[attnum - 1]);
+							 &in_func_oid, &typioparams[attphysnum - 1]);
+		fmgr_info(in_func_oid, &in_functions[attphysnum - 1]);
 
 		/* Get default info if needed */
-		if (!list_member_int(cstate->attnumlist, attnum) && !att->attgenerated)
+		if (!list_member_int(cstate->attnumlist, attphysnum) && !att->attgenerated)
 		{
 			/* attribute is NOT to be copied from input */
 			/* use default value if one exists */
 			Expr	   *defexpr = (Expr *) build_column_default(cstate->rel,
-																attnum);
+																attphysnum);
 
 			if (defexpr != NULL)
 			{
@@ -1433,7 +1433,7 @@ BeginCopyFrom(ParseState *pstate,
 
 				/* Initialize executable expression in copycontext */
 				defexprs[num_defaults] = ExecInitExpr(defexpr, NULL);
-				defmap[num_defaults] = attnum - 1;
+				defmap[num_defaults] = attphysnum - 1;
 				num_defaults++;
 
 				/*
diff --git a/src/backend/commands/copyfromparse.c b/src/backend/commands/copyfromparse.c
index 57813b3458..e9b0b294e9 100644
--- a/src/backend/commands/copyfromparse.c
+++ b/src/backend/commands/copyfromparse.c
@@ -788,9 +788,9 @@ NextCopyFromRawFields(CopyFromState cstate, char ***fields, int *nfields)
 			fldnum = 0;
 			foreach(cur, cstate->attnumlist)
 			{
-				int			attnum = lfirst_int(cur);
+				int			attphysnum = lfirst_int(cur);
 				char	   *colName;
-				Form_pg_attribute attr = TupleDescAttr(tupDesc, attnum - 1);
+				Form_pg_attribute attr = TupleDescAttr(tupDesc, attphysnum - 1);
 
 				Assert(fldnum < cstate->max_fields);
 
@@ -894,8 +894,8 @@ NextCopyFrom(CopyFromState cstate, ExprContext *econtext,
 		/* Loop to read the user attributes on the line. */
 		foreach(cur, cstate->attnumlist)
 		{
-			int			attnum = lfirst_int(cur);
-			int			m = attnum - 1;
+			int			attphysnum = lfirst_int(cur);
+			int			m = attphysnum - 1;
 			Form_pg_attribute att = TupleDescAttr(tupDesc, m);
 
 			if (fieldno >= fldct)
@@ -991,8 +991,8 @@ NextCopyFrom(CopyFromState cstate, ExprContext *econtext,
 
 		foreach(cur, cstate->attnumlist)
 		{
-			int			attnum = lfirst_int(cur);
-			int			m = attnum - 1;
+			int			attphysnum = lfirst_int(cur);
+			int			m = attphysnum - 1;
 			Form_pg_attribute att = TupleDescAttr(tupDesc, m);
 
 			cstate->cur_attname = NameStr(att->attname);
diff --git a/src/backend/commands/copyto.c b/src/backend/commands/copyto.c
index fca29a9a10..e0306cc11b 100644
--- a/src/backend/commands/copyto.c
+++ b/src/backend/commands/copyto.c
@@ -579,15 +579,15 @@ BeginCopyTo(ParseState *pstate,
 
 		foreach(cur, attnums)
 		{
-			int			attnum = lfirst_int(cur);
-			Form_pg_attribute attr = TupleDescAttr(tupDesc, attnum - 1);
+			int			attphysnum = lfirst_int(cur);
+			Form_pg_attribute attr = TupleDescAttr(tupDesc, attphysnum - 1);
 
-			if (!list_member_int(cstate->attnumlist, attnum))
+			if (!list_member_int(cstate->attnumlist, attphysnum))
 				ereport(ERROR,
 						(errcode(ERRCODE_INVALID_COLUMN_REFERENCE),
 						 errmsg("FORCE_QUOTE column \"%s\" not referenced by COPY",
 								NameStr(attr->attname))));
-			cstate->opts.force_quote_flags[attnum - 1] = true;
+			cstate->opts.force_quote_flags[attphysnum - 1] = true;
 		}
 	}
 
@@ -602,15 +602,15 @@ BeginCopyTo(ParseState *pstate,
 
 		foreach(cur, attnums)
 		{
-			int			attnum = lfirst_int(cur);
-			Form_pg_attribute attr = TupleDescAttr(tupDesc, attnum - 1);
+			int			attphysnum = lfirst_int(cur);
+			Form_pg_attribute attr = TupleDescAttr(tupDesc, attphysnum - 1);
 
-			if (!list_member_int(cstate->attnumlist, attnum))
+			if (!list_member_int(cstate->attnumlist, attphysnum))
 				ereport(ERROR,
 						(errcode(ERRCODE_INVALID_COLUMN_REFERENCE),
 						 errmsg("FORCE_NOT_NULL column \"%s\" not referenced by COPY",
 								NameStr(attr->attname))));
-			cstate->opts.force_notnull_flags[attnum - 1] = true;
+			cstate->opts.force_notnull_flags[attphysnum - 1] = true;
 		}
 	}
 
@@ -625,15 +625,15 @@ BeginCopyTo(ParseState *pstate,
 
 		foreach(cur, attnums)
 		{
-			int			attnum = lfirst_int(cur);
-			Form_pg_attribute attr = TupleDescAttr(tupDesc, attnum - 1);
+			int			attphysnum = lfirst_int(cur);
+			Form_pg_attribute attr = TupleDescAttr(tupDesc, attphysnum - 1);
 
-			if (!list_member_int(cstate->attnumlist, attnum))
+			if (!list_member_int(cstate->attnumlist, attphysnum))
 				ereport(ERROR,
 						(errcode(ERRCODE_INVALID_COLUMN_REFERENCE),
 						 errmsg("FORCE_NULL column \"%s\" not referenced by COPY",
 								NameStr(attr->attname))));
-			cstate->opts.force_null_flags[attnum - 1] = true;
+			cstate->opts.force_null_flags[attphysnum - 1] = true;
 		}
 	}
 
@@ -793,10 +793,10 @@ DoCopyTo(CopyToState cstate)
 	cstate->out_functions = (FmgrInfo *) palloc(num_phys_attrs * sizeof(FmgrInfo));
 	foreach(cur, cstate->attnumlist)
 	{
-		int			attnum = lfirst_int(cur);
+		int			attphysnum = lfirst_int(cur);
 		Oid			out_func_oid;
 		bool		isvarlena;
-		Form_pg_attribute attr = TupleDescAttr(tupDesc, attnum - 1);
+		Form_pg_attribute attr = TupleDescAttr(tupDesc, attphysnum - 1);
 
 		if (cstate->opts.binary)
 			getTypeBinaryOutputInfo(attr->atttypid,
@@ -806,7 +806,7 @@ DoCopyTo(CopyToState cstate)
 			getTypeOutputInfo(attr->atttypid,
 							  &out_func_oid,
 							  &isvarlena);
-		fmgr_info(out_func_oid, &cstate->out_functions[attnum - 1]);
+		fmgr_info(out_func_oid, &cstate->out_functions[attphysnum - 1]);
 	}
 
 	/*
@@ -851,14 +851,14 @@ DoCopyTo(CopyToState cstate)
 
 			foreach(cur, cstate->attnumlist)
 			{
-				int			attnum = lfirst_int(cur);
+				int			attphysnum = lfirst_int(cur);
 				char	   *colname;
 
 				if (hdr_delim)
 					CopySendChar(cstate, cstate->opts.delim[0]);
 				hdr_delim = true;
 
-				colname = NameStr(TupleDescAttr(tupDesc, attnum - 1)->attname);
+				colname = NameStr(TupleDescAttr(tupDesc, attphysnum - 1)->attname);
 
 				if (cstate->opts.csv_mode)
 					CopyAttributeOutCSV(cstate, colname, false,
@@ -950,9 +950,9 @@ CopyOneRowTo(CopyToState cstate, TupleTableSlot *slot)
 
 	foreach(cur, cstate->attnumlist)
 	{
-		int			attnum = lfirst_int(cur);
-		Datum		value = slot->tts_values[attnum - 1];
-		bool		isnull = slot->tts_isnull[attnum - 1];
+		int			attphysnum = lfirst_int(cur);
+		Datum		value = slot->tts_values[attphysnum - 1];
+		bool		isnull = slot->tts_isnull[attphysnum - 1];
 
 		if (!cstate->opts.binary)
 		{
@@ -972,11 +972,11 @@ CopyOneRowTo(CopyToState cstate, TupleTableSlot *slot)
 		{
 			if (!cstate->opts.binary)
 			{
-				string = OutputFunctionCall(&out_functions[attnum - 1],
+				string = OutputFunctionCall(&out_functions[attphysnum - 1],
 											value);
 				if (cstate->opts.csv_mode)
 					CopyAttributeOutCSV(cstate, string,
-										cstate->opts.force_quote_flags[attnum - 1],
+										cstate->opts.force_quote_flags[attphysnum - 1],
 										list_length(cstate->attnumlist) == 1);
 				else
 					CopyAttributeOutText(cstate, string);
@@ -985,7 +985,7 @@ CopyOneRowTo(CopyToState cstate, TupleTableSlot *slot)
 			{
 				bytea	   *outputbytes;
 
-				outputbytes = SendFunctionCall(&out_functions[attnum - 1],
+				outputbytes = SendFunctionCall(&out_functions[attphysnum - 1],
 											   value);
 				CopySendInt32(cstate, VARSIZE(outputbytes) - VARHDRSZ);
 				CopySendData(cstate, VARDATA(outputbytes),
diff --git a/src/backend/commands/createas.c b/src/backend/commands/createas.c
index 9abbb6b555..ec046d77cf 100644
--- a/src/backend/commands/createas.c
+++ b/src/backend/commands/createas.c
@@ -453,7 +453,7 @@ intorel_startup(DestReceiver *self, int operation, TupleDesc typeinfo)
 	ObjectAddress intoRelationAddr;
 	Relation	intoRelationDesc;
 	ListCell   *lc;
-	int			attnum;
+	int			attphysnum;
 
 	Assert(into != NULL);		/* else somebody forgot to set it */
 
@@ -468,9 +468,9 @@ intorel_startup(DestReceiver *self, int operation, TupleDesc typeinfo)
 	 */
 	attrList = NIL;
 	lc = list_head(into->colNames);
-	for (attnum = 0; attnum < typeinfo->natts; attnum++)
+	for (attphysnum = 0; attphysnum < typeinfo->natts; attphysnum++)
 	{
-		Form_pg_attribute attribute = TupleDescAttr(typeinfo, attnum);
+		Form_pg_attribute attribute = TupleDescAttr(typeinfo, attphysnum);
 		ColumnDef  *col;
 		char	   *colname;
 
diff --git a/src/backend/commands/event_trigger.c b/src/backend/commands/event_trigger.c
index 4642527881..2b3dbfbcb1 100644
--- a/src/backend/commands/event_trigger.c
+++ b/src/backend/commands/event_trigger.c
@@ -1211,14 +1211,14 @@ EventTriggerSQLDropAddObject(const ObjectAddress *object, bool original, bool no
 
 		if (tuple)
 		{
-			AttrNumber	attnum;
+			AttrNumber	attphysnum;
 			Datum		datum;
 			bool		isnull;
 
-			attnum = get_object_attnum_namespace(obj->address.classId);
-			if (attnum != InvalidAttrNumber)
+			attphysnum = get_object_attnum_namespace(obj->address.classId);
+			if (attphysnum != InvalidAttrNumber)
 			{
-				datum = heap_getattr(tuple, attnum,
+				datum = heap_getattr(tuple, attphysnum,
 									 RelationGetDescr(catalog), &isnull);
 				if (!isnull)
 				{
@@ -1249,10 +1249,10 @@ EventTriggerSQLDropAddObject(const ObjectAddress *object, bool original, bool no
 			if (get_object_namensp_unique(obj->address.classId) &&
 				obj->address.objectSubId == 0)
 			{
-				attnum = get_object_attnum_name(obj->address.classId);
-				if (attnum != InvalidAttrNumber)
+				attphysnum = get_object_attnum_name(obj->address.classId);
+				if (attphysnum != InvalidAttrNumber)
 				{
-					datum = heap_getattr(tuple, attnum,
+					datum = heap_getattr(tuple, attphysnum,
 										 RelationGetDescr(catalog), &isnull);
 					if (!isnull)
 						obj->objname = pstrdup(NameStr(*DatumGetName(datum)));
diff --git a/src/backend/commands/indexcmds.c b/src/backend/commands/indexcmds.c
index 99f5ab83c3..4460201217 100644
--- a/src/backend/commands/indexcmds.c
+++ b/src/backend/commands/indexcmds.c
@@ -1823,7 +1823,7 @@ ComputeIndexAttrs(IndexInfo *indexInfo,
 									attribute->name)));
 			}
 			attform = (Form_pg_attribute) GETSTRUCT(atttuple);
-			indexInfo->ii_IndexAttrNumbers[attn] = attform->attnum;
+			indexInfo->ii_IndexAttrNumbers[attn] = attform->attphysnum;
 			atttype = attform->atttypid;
 			attcollation = attform->attcollation;
 			ReleaseSysCache(atttuple);
diff --git a/src/backend/commands/matview.c b/src/backend/commands/matview.c
index d1ee106465..47ea6f6246 100644
--- a/src/backend/commands/matview.c
+++ b/src/backend/commands/matview.c
@@ -705,9 +705,9 @@ refresh_by_match_merge(Oid matviewOid, Oid tempOid, Oid relowner,
 			/* Add quals for all columns from this index. */
 			for (i = 0; i < indnkeyatts; i++)
 			{
-				int			attnum = indexStruct->indkey.values[i];
+				int			attphysnum = indexStruct->indkey.values[i];
 				Oid			opclass = indclass->values[i];
-				Form_pg_attribute attr = TupleDescAttr(tupdesc, attnum - 1);
+				Form_pg_attribute attr = TupleDescAttr(tupdesc, attphysnum - 1);
 				Oid			attrtype = attr->atttypid;
 				HeapTuple	cla_ht;
 				Form_pg_opclass cla_tup;
@@ -747,9 +747,9 @@ refresh_by_match_merge(Oid matviewOid, Oid tempOid, Oid relowner,
 				 * that's so unlikely it doesn't seem worth spending extra
 				 * code to avoid.
 				 */
-				if (opUsedForQual[attnum - 1] == op)
+				if (opUsedForQual[attphysnum - 1] == op)
 					continue;
-				opUsedForQual[attnum - 1] = op;
+				opUsedForQual[attphysnum - 1] = op;
 
 				/*
 				 * Actually add the qual, ANDed with any others.
@@ -894,9 +894,9 @@ is_usable_unique_index(Relation indexRel)
 
 		for (i = 0; i < numatts; i++)
 		{
-			int			attnum = indexStruct->indkey.values[i];
+			int			attphysnum = indexStruct->indkey.values[i];
 
-			if (attnum <= 0)
+			if (attphysnum <= 0)
 				return false;
 		}
 		return true;
diff --git a/src/backend/commands/publicationcmds.c b/src/backend/commands/publicationcmds.c
index 8e645741e4..4a4c6ffac5 100644
--- a/src/backend/commands/publicationcmds.c
+++ b/src/backend/commands/publicationcmds.c
@@ -265,7 +265,7 @@ contain_invalid_rfcolumn_walker(Node *node, rf_context *context)
 	if (IsA(node, Var))
 	{
 		Var		   *var = (Var *) node;
-		AttrNumber	attnum = var->varattno;
+		AttrNumber	attphysnum = var->varattno;
 
 		/*
 		 * If pubviaroot is true, we are validating the row filter of the
@@ -275,12 +275,12 @@ contain_invalid_rfcolumn_walker(Node *node, rf_context *context)
 		 */
 		if (context->pubviaroot)
 		{
-			char	   *colname = get_attname(context->parentid, attnum, false);
+			char	   *colname = get_attname(context->parentid, attphysnum, false);
 
-			attnum = get_attnum(context->relid, colname);
+			attphysnum = get_attphysnum(context->relid, colname);
 		}
 
-		if (!bms_is_member(attnum - FirstLowInvalidHeapAttributeNumber,
+		if (!bms_is_member(attphysnum - FirstLowInvalidHeapAttributeNumber,
 						   context->bms_replident))
 			return true;
 	}
@@ -436,7 +436,7 @@ pub_collist_contains_invalid_column(Oid pubid, Relation relation, List *ancestor
 		x = -1;
 		while ((x = bms_next_member(idattrs, x)) >= 0)
 		{
-			AttrNumber	attnum = (x + FirstLowInvalidHeapAttributeNumber);
+			AttrNumber	attphysnum = (x + FirstLowInvalidHeapAttributeNumber);
 
 			/*
 			 * If pubviaroot is true, we are validating the column list of the
@@ -448,17 +448,17 @@ pub_collist_contains_invalid_column(Oid pubid, Relation relation, List *ancestor
 			if (pubviaroot)
 			{
 				/* attribute name in the child table */
-				char	   *colname = get_attname(relid, attnum, false);
+				char	   *colname = get_attname(relid, attphysnum, false);
 
 				/*
-				 * Determine the attnum for the attribute name in parent (we
+				 * Determine the attphysnum for the attribute name in parent (we
 				 * are using the column list defined on the parent).
 				 */
-				attnum = get_attnum(publish_as_relid, colname);
+				attphysnum = get_attphysnum(publish_as_relid, colname);
 			}
 
 			/* replica identity column, not covered by the column list */
-			if (!bms_is_member(attnum, columns))
+			if (!bms_is_member(attphysnum, columns))
 			{
 				result = true;
 				break;
@@ -1228,9 +1228,9 @@ AlterPublicationTables(AlterPublicationStmt *stmt, HeapTuple tup,
 					foreach(lc, newpubrel->columns)
 					{
 						char	   *colname = strVal(lfirst(lc));
-						AttrNumber	attnum = get_attnum(newrelid, colname);
+						AttrNumber	attphysnum = get_attphysnum(newrelid, colname);
 
-						newcolumns = bms_add_member(newcolumns, attnum);
+						newcolumns = bms_add_member(newcolumns, attphysnum);
 					}
 				}
 
diff --git a/src/backend/commands/sequence.c b/src/backend/commands/sequence.c
index ddf219b21f..0fb47c6d81 100644
--- a/src/backend/commands/sequence.c
+++ b/src/backend/commands/sequence.c
@@ -1595,7 +1595,7 @@ process_owned_by(Relation seqrel, List *owned_by, bool for_identity)
 	DependencyType deptype;
 	int			nnames;
 	Relation	tablerel;
-	AttrNumber	attnum;
+	AttrNumber	attphysnum;
 
 	deptype = for_identity ? DEPENDENCY_INTERNAL : DEPENDENCY_AUTO;
 
@@ -1610,7 +1610,7 @@ process_owned_by(Relation seqrel, List *owned_by, bool for_identity)
 					 errmsg("invalid OWNED BY option"),
 					 errhint("Specify OWNED BY table.column or OWNED BY NONE.")));
 		tablerel = NULL;
-		attnum = 0;
+		attphysnum = 0;
 	}
 	else
 	{
@@ -1648,8 +1648,8 @@ process_owned_by(Relation seqrel, List *owned_by, bool for_identity)
 					 errmsg("sequence must be in same schema as table it is linked to")));
 
 		/* Now, fetch the attribute number from the system cache */
-		attnum = get_attnum(RelationGetRelid(tablerel), attrname);
-		if (attnum == InvalidAttrNumber)
+		attphysnum = get_attphysnum(RelationGetRelid(tablerel), attrname);
+		if (attphysnum == InvalidAttrNumber)
 			ereport(ERROR,
 					(errcode(ERRCODE_UNDEFINED_COLUMN),
 					 errmsg("column \"%s\" of relation \"%s\" does not exist",
@@ -1687,7 +1687,7 @@ process_owned_by(Relation seqrel, List *owned_by, bool for_identity)
 
 		refobject.classId = RelationRelationId;
 		refobject.objectId = RelationGetRelid(tablerel);
-		refobject.objectSubId = attnum;
+		refobject.objectSubId = attphysnum;
 		depobject.classId = RelationRelationId;
 		depobject.objectId = RelationGetRelid(seqrel);
 		depobject.objectSubId = 0;
diff --git a/src/backend/commands/statscmds.c b/src/backend/commands/statscmds.c
index 2e716743dd..737ee30e64 100644
--- a/src/backend/commands/statscmds.c
+++ b/src/backend/commands/statscmds.c
@@ -241,7 +241,7 @@ CreateStatistics(CreateStatsStmt *stmt)
 			attForm = (Form_pg_attribute) GETSTRUCT(atttuple);
 
 			/* Disallow use of system attributes in extended stats */
-			if (attForm->attnum <= 0)
+			if (attForm->attphysnum <= 0)
 				ereport(ERROR,
 						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 						 errmsg("statistics creation on system columns is not supported")));
@@ -254,7 +254,7 @@ CreateStatistics(CreateStatsStmt *stmt)
 						 errmsg("column \"%s\" cannot be used in statistics because its type %s has no default btree operator class",
 								attname, format_type_be(attForm->atttypid))));
 
-			attnums[nattnums] = attForm->attnum;
+			attnums[nattnums] = attForm->attphysnum;
 			nattnums++;
 			ReleaseSysCache(atttuple);
 		}
@@ -296,9 +296,9 @@ CreateStatistics(CreateStatsStmt *stmt)
 			k = -1;
 			while ((k = bms_next_member(attnums, k)) >= 0)
 			{
-				AttrNumber	attnum = k + FirstLowInvalidHeapAttributeNumber;
+				AttrNumber	attphysnum = k + FirstLowInvalidHeapAttributeNumber;
 
-				if (attnum <= 0)
+				if (attphysnum <= 0)
 					ereport(ERROR,
 							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 							 errmsg("statistics creation on system columns is not supported")));
